#!/usr/bin/env node

const util = require('util')
const http = require("http")
const querystring = require('querystring')
const crypto = require('crypto')

const argv = require('yargs')
	.usage(
		"$0 [username] [password]", 
		"Try logging in to BUPT's school network, gaining access to internet", (yargs) => {
			yargs
				.demandOption(["username", "password"])
				.positional('username', {
					describe: "Usually the 10-digit ID on your student card", 
					type: "string"
				})
				.positional('password', {
					describe: "The password for school gateway login", 
					type: "string"
				})
		})
	.help()
	.argv
 
var options = {
    host:'10.3.8.211',
    path:'/',
    method:'POST',
    headers:{
        'Content-Type' : 'application/x-www-form-urlencoded',
        'Content-Length' : 0
    }
}

async function try_bupt_login(username, password)
{
	var contents = querystring.stringify({
	    "DDDDD": username, 
	    "upass": password, 
	    "0MKKey": ""
	})
	options["headers"]["Content-Length"] = contents.length
	var res = await new Promise((resolve, reject) => {
		var req = http.request(options, resolve)
		req.write(contents)
		req.end()
	})
	res.setEncoding('utf8')
	var chunks_md5 = crypto.createHash('md5')
	res.on('data', (chunk) => {
		chunks_md5.update(chunk)
	})
	await new Promise((resolve, reject) => {
		res.on("end", resolve)
	})
	return chunks_md5.digest("hex")
}

(async function ()
{
	process.stdout.write(await try_bupt_login(argv.username, argv.password))
})()
